Subject: bug#48352: Haskell cabal new-build fails

From: Bone Baboon <[email-masked]>
Date: Tue, 11 May 2021 10:23:48 -0400

I am experiencing an error when I try to compile a Haskell program with
Cabal a Haskell build tool.

Previously I had Cabal working and was able to compile Haskell
programs.
https://lists.gnu.org/archive/html/help-guix/2021-04/msg00096.html

Now when I try to build a Haskell program with `cabal new-build` I get
an error.

`guix describe` outputs:

```
Generation 14   May 11 2021 08:06:01    (current)
  guix bddad00
    repository URL: https://git.savannah.gnu.org/git/guix.git
    branch: master
    commit: bddad00bffc5837e89942756fa5b7234f63f1f47
```

The error message:

```
Build profile: -w ghc-8.6.5 -O1
In order, the following will be built (use -v for more details):
 - <program>-0.1.0.0 (exe:<program>) (first run)
Preprocessing executable '<program>' for <program>-0.1.0.0..
Building executable '<program>' for <program>-0.1.0.0..
Linking <program-source-code-directory>/dist-newstyle/build/x86_64-linux/ghc-8.6.5/<program>-0.1.0.0/x/<program>/build/<program>/<program> ...

In file included from /gnu/store/fa6wj5bxkj5ll1d7292a70knmyl7a0cr-glibc-2.31/include/errno.h:28:0: error:
    0,
                     from /gnu/store/5i95kk1qdfvl6ld3hf6a4q7kxw6sgpkv-ghc-8.6.5/lib/ghc-8.6.5/include/rts/OSThreads.h:28,
                     from /gnu/store/5i95kk1qdfvl6ld3hf6a4q7kxw6sgpkv-ghc-8.6.5/lib/ghc-8.6.5/include/Rts.h:168,
                     from /tmp/ghc8802_0/ghc_1.c:1:

/gnu/store/fa6wj5bxkj5ll1d7292a70knmyl7a0cr-glibc-2.31/include/bits/errno.h:26:11: error:
     fatal error: linux/errno.h: No such file or directory
     # include <linux/errno.h>
               ^~~~~~~~~~~~~~~
   |
26 | # include <linux/errno.h>
   |           ^
compilation terminated.
`gcc' failed in phase `C Compiler'. (Exit code: 1)
```